LRpair <- function (p1 = c(0.5, 0.5), p2 = c(0.5, 0.5), rho = 0.5, ped = NULL, 
                    H1 = NULL, H2 = NULL) 
{
    numerator <- denominator <- alleles <- NULL
    if ((length(p1)|length(p2)) > 2) 
        stop("Only works for SNP-s ")
    if (class(ped) != "linkdat") 
        stop(" ped should of class linkdat")
    for (g11 in list(c(1, 1), c(1, 2), c(2, 2))) for (g12 in list(c(1, 
        1), c(1, 2), c(2, 2))) for (g21 in list(c(1, 1), c(1, 
        2), c(2, 2))) for (g22 in list(c(1, 1), c(1, 2), c(2, 
        2))) {
        m1 <- marker(ped, alleles = 1:2, H1[1], g11, afreq = p1)
        m2 <- marker(ped, alleles = 1:2, H1[1], g12, afreq = p2)
        res <- twoMarkerDistribution(ped, H1[2], m1, m2, theta = rho, 
            verbose = FALSE)
        foo1 <- paste(g21, sep = "", collapse = "/")
        foo2 <- paste(g22, sep = "", collapse = "/")
        fact <- length(unique(g11)) * length(unique(g12)) * prod(p1[g11]) * 
            prod(p2[g12])
        numerator <- c(numerator, res[foo1, foo2] * fact)
        m1 <- marker(ped, alleles = 1:2, H2[1], g11, afreq = p1)
        m2 <- marker(ped, alleles = 1:2, H2[1], g12, afreq = p2)
        res <- twoMarkerDistribution(ped, H2[2], m1, m2, theta = rho, 
            verbose = FALSE)
        denominator <- c(denominator, res[foo1, foo2] * fact)
        alleles <- rbind(alleles, c(g11, g12, g21, g22))
    }
    foo <- data.frame(alleles, numerator, denominator, LR = numerator/denominator)
    foo2 <- split(foo, foo$LR)
    foo3 <- data.frame(t(sapply(foo2, function(x) 
      apply(x[, c(9,10)], 2, sum))))
    foo3 <- data.frame(foo3, LR = as.double(rownames(foo3)))
    rownames(foo3) <- NULL
    ELR.H2 <- sum(foo3$denominator * foo3$LR)
    ELR2.H2 <- sum(foo3$denominator * foo3$LR^2)
    sdLR.H2 <- sqrt(ELR2.H2 - ELR.H2^2)
    ElnLR.H2 <- sum(foo3$denominator * log(foo3$LR))
    ElnLR2.H2 <- sum(foo3$denominator * log(foo3$LR)^2)
    sdlnLR.H2 <- sqrt(ElnLR2.H2 - ElnLR.H2^2)
    ELR.H1 <- sum(foo3$numerator * foo3$LR)
    ELR2.H1 <- sum(foo3$numerator * foo3$LR^2)
    sdLR.H1 <- sqrt(ELR2.H1 - ELR.H1^2)
    ElnLR.H1 <- sum(foo3$numerator * log(foo3$LR))
    ElnLR2.H1 <- sum(foo3$numerator * log(foo3$LR)^2)
    sdlnLR.H1 <- sqrt(ElnLR2.H1 - ElnLR.H1^2)
    moments <- data.frame(numerator = c(ELR.H1, sdLR.H1, ElnLR.H1, 
        sdlnLR.H1), denominator = c(ELR.H2, sdLR.H2, ElnLR.H2, 
        sdlnLR.H2))
    rownames(moments) <- c("E", "sd", "Eln", "sdLn")
    list(table.unique = foo3, table.all = foo, moments = moments)
}
