conditionalLikelihoods <- function(M,c,p,d,g){
            
buildGmatrix <- function(nalleles,g){
ni <- matrix(nrow=dim(g)[1],ncol=nalleles,0)
for (i in 1:dim(g)[1]){
     if (g[i,1]==g[i,2])
     ni[i,g[i,1]] <- 2 else ni[i,g[i,]] <- c(1,1)
}
ni
}

find.p.inM <- function(mat,c,pa,d){
 A <- dim(mat)[2]
 p.inM <- rep(NA,A)
 for (a in 1:A)
  p.inM[a] <- 1-(1-c*pa[a])*prod(d^mat[,a])
p.inM
}

checkInputCLik <- function(M,c,p,d,g){
if(any(duplicated(M))) 
 stop("Mixture should be different integers")
if(!is.numeric(c)||c<0||c>1)
 stop("dropin parameter c must be a real in [0,1)")
if (!is.numeric(p) || any(p < 0)||any(p>1)||sum(p)>1)                            
 stop("frequencies must be  positive numbers in (0,1) summing to 1")
if (!is.numeric(d) || any(d < 0)||any(d>1))                            
  stop("drop-out parameters must be  non-negative positive numbers in [0,1]")
if(!is.matrix(g))
 stop("Last argument should be matrix of integers with rows equal to the number of contributors")
0
}
checkInputCLik(M,c,p,d,g)
nalleles <- length(p)
I <- rep(0,nalleles)

d2 <- dim(g)[2]/2
cLikelihood <- rep(NA,d2)
for (j in 1:d2){
      niMat <- buildGmatrix(nalleles,g[,c(2*j-1,2*j)])
      p.inM <- find.p.inM(niMat,c,p,d)
      I[M]<-1
      cLikelihood[j] <- prod(I*p.inM+(1-I)*(1-p.inM))
 }
list(likelihood=cLikelihood, p.in.M=p.inM)
}



