lambdaEst <- function(P ,data, pl=TRUE, first=log(0.01), last=log(10000),ngrid=1000){
 lMultivariateBeta <- function(alpha)
                  sum(lgamma(alpha)) - lgamma(sum(alpha))
 loglik <- function(data, lambda, P)
       lMultivariateBeta (lambda*P + data) -
       lMultivariateBeta (lambda*P)
 if (!is.numeric(P) || any(P <= 0)) 
            stop("frequencies must be a vector of positive numbers.")
        if (round(sum(P), 6) != 1) 
            stop("The frequencies must sum to 1.")
 if(any(data<0))
            stop("Second argument data must be non-negative integers")
   lambda <- exp(seq(first,last, length.out = ngrid))
   loglikelihood <- lambda
   for (i in 1:ngrid) loglikelihood[i] <- loglik (data, lambda[i], P)
   lambda.est <- lambda[which.max(loglikelihood)]
   if(!is.double(lambda.est)) stop("lambda estimate not found, likelihood calculations failed?")
   if(pl) plot(lambda, loglikelihood,  type="l",ylab="log likelihood")
   list(lambda.est=lambda.est, loglik=loglikelihood)
}