moments <- function(p1=c(0.5,0.5), km=c(0.5,0.5,0), p2=NULL,  km.marked=NULL){

var2 <- function(km,p1,p2,E, km.marked = NULL){
		if(is.null(km.marked))  km.marked <- km
		M1 <- findAs(p1)
		M2 <- findAs(p2)
		EE2 <- 0
		for (i1 in 1:3)
		for (i2 in 1:3)
		for (j1 in 1:3)
		for (j2 in 1:3)
		for (l1 in 1:3)
		for (l2 in 1:3)
		EE2 <- EE2+km[i1,i2]*km[j1,j2]*km.marked[l1,l2]*M1[[l1]][i1,j1]*M2[[l2]][i2,j2]
as.double(EE2-E^2)
}


En2 <- function(L1,L2, km = NULL, km.marked = NULL){
				line1 <- c(1,1,1)
				line2 <- c(1,(L1+3)/4, (L1+1)/2)
				line3 <- c(1, (L1+1)/2,L1*(L1+1)/2)
				M1 <- rbind(line1, line2, line3)
				line2 <- c(1,(L2+3)/4, (L2+1)/2)
				line3 <- c(1, (L2+1)/2,L2*(L2+1)/2)
				M2 <- rbind(line1, line2, line3)
				E <- 0
				for (i1 in 1:3)
				for (i2 in 1:3)
				for (j1 in 1:3)
				for (j2 in 1:3)
				E <- E+km[i1,i2]*km.marked[j1,j2]*M1[i1,j1]*M2[i2,j2]
as.double(E)
}

findAs <- function(p){
		L <- length(p)
		s1 <- s2 <- s3 <- 0
		for( a in 1:(L-1))
			for (b in (a+1):L){
				s1 <- s1 + p[a]/p[b]+p[b]/p[a]
				s2 <- s2 + 1/(2*p[a]*p[b])
				s3 <- s3 + (1/p[b])+(1/p[a])
			}
			line1 <- c(1,1,1)
			line2 <- c(1,(L+3)/4, (L+1)/2)
			line3 <- c(1, (L+1)/2,L*(L+1)/2)
			A0 <- rbind(line1, line2, line3)
			A1 <- matrix(ncol=3,nrow=3,NA)
			A1[1,] <- A1[,1] <- line2
			A1[2,2] <- (5*L+3)/8+s1/16
			A1[3,3] <- sum(1/p)+s3/4
			A1[3,2] <- A1[2,3] <- L*(L+7)/8+s1/8
			A2 <- matrix(ncol=3,nrow=3,NA)
			A2[1,] <- A2[,1] <- line3
			A2[2,2] <- A1[3,2]
			A2[3,2] <- A2[2,3] <- sum(1/p)+s3/4
			A2[3,3] <- sum(1/(p^2))+s2
			list(A0=A0, A1=A1,A2=A2)
}
exactMom <- function(k,p, As, k.marked = NULL){
			if(is.null(k.marked)) k.marked <- k
				E <- t(k)%*%As[[1]]%*%k.marked
				E2 <- k[1]*E
				for (i in 2:3)
					E2 <- E2+k[i]*(t(k)%*%As[[i]]%*%k.marked)
	list(E.LR=E,  varLR=E2-E^2)
}
    if (!is.numeric(p1) || any(p1<= 0))
        stop("frequencies must be a vector of positive numbers.")
    if (round(sum(p1), 6) != 1)
        stop("The frequencies must sum to 1.")
	if(is.null(p2)&is.matrix(km))
		stop("p2 needed")
	if(is.null(p2)){
	    As <- findAs(p1)
        res <- exactMom(k=km, p1, As, k.marked = km.marked)
		return(res)
		}
	    if (!is.numeric(p2) || any(p2<= 0))
        stop("frequencies must be a vector of positive numbers.")
    if (round(sum(p2), 6) != 1)
        stop("The frequencies must sum to 1.")
	if (!is.matrix(km)) stop("km must be 3 by 3 matrix for two markers.")
	if (is.null(km.marked)) km.marked <- km
	mu <- En2(L1=length(p1),L2=length(p2),km,km.marked)
    s2 <- var2(km,p1,p2,E=mu, km.marked = km.marked)
	list(E.LR=mu, varLR=s2)
}
