library(paramlink)
nMarkers = 100
L =  10
a=sample(1:2,nMarkers,rep=T)
a=sample(L,nMarkers,rep=T)
b=sample(L,nMarkers,rep=T)
cc=sample(L,nMarkers,rep=T)
d=sample(L,nMarkers,rep=T)

afreq = list("vector",5)
for (i in 1:5)
  afreq[[i]] =sample(1:10)


afreq = 1:L; afreq =afreq/sum(afreq)

mat = cbind(a,b,cc,d)
x = fullSibMating(2)
Delta = jacquard(x,c(5,6))
foo=lik2vec(a, b, cc, d, afreq, Delta)
dim(foo$index)


# Example. There are 9 genotypes for a pair
# of individuals corresponding to  9 the Jacquard states.
# Below the likelihood of these cases are calculated and checed against
# paramlink
a  = c(1,1,1,1,1,2,1,1,1)
b  = c(1,1,1,1,2,3,2,2,2)
cc = c(1,2,1,2,1,1,1,1,3)
d  = c(1,2,2,3,1,1,2,3,4)
mat = cbind(a,b,cc,d)
p = c(0.1,0.2,0.3,0.4)
l2 = lik2vec(a,b,cc,d, afreq=p, Delta=Delta)
nMarkers = length(a)
l2.paramlink = rep(NA,length(l2))
for (i in 1: nMarkers){
  m = marker(x, alleles=1:4, afreq = p, 5, c(a[i],b[i]), 6, c(cc[i],d[i]))
  l2.paramlink[i] = log(likelihood(x,m))
}
res = cbind(l2$loglik,l2.paramlink)
foo = apply(res,1,function(x) abs(x[1]-x[2])<1e-15)


### Continued, but with simulated data.
Nsim = 100 #Increase
p=c(0.1,0.2,0.3,0.4)
p=1:10; p=p/sum(p)
set.seed(17)
loglik.paramlink =rep(NA, Nsim)
x = fullSibMating(2)
m = marker(x, alleles = 1:length(p), afreq=p)
x = addMarker(x,m)
x = markerSim(x,N=Nsim,available=c(5,6), alleles=1:length(p), afreq=p)
foo = as.data.frame(x)
x = breakLoops(x)
for (i in 1:Nsim)
 loglik.paramlink[i] = log(likelihood(x,x$markerdata[[i]]))
res1 = sum(loglik.paramlink)


a =foo[5,seq(6,2*Nsim+5,by=2)]
a=as.integer(a)
b =foo[5,seq(7,2*Nsim+5,by=2)]
b=as.integer(b)
cc = foo[6,seq(6,2*Nsim+5,by=2)]
cc=as.integer(cc)
d = foo[6,seq(7,2*Nsim+5,by=2)]
d=as.integer(d)
foo2 = lik2vec(a,b,cc,d,afreq=p,Delta)
res2 = sum(foo2$loglik)

### Continued. ML estimate

Nsim = 1000 #Increase
p=1:100;p=p/sum(p)
rep(1/1000,1000)
set.seed(17)
loglik.paramlink =rep(NA, Nsim)
x = fullSibMating(2)

ids = c(5,6)
ids = c(1,3)
m = marker(x, alleles = 1:length(p), afreq=p)
x = addMarker(x,m)
x = markerSim(x,N=Nsim,available=ids, alleles=1:length(p), afreq=p)
foo = as.data.frame(x)
a =foo[ids[1],seq(6,2*Nsim+5,by=2)]
a=as.integer(a)
b =foo[ids[1],seq(7,2*Nsim+5,by=2)]
b=as.integer(b)
cc = foo[ids[2],seq(6,2*Nsim+5,by=2)]
cc=as.integer(cc)
d = foo[ids[2],seq(7,2*Nsim+5,by=2)]
d=as.integer(d)
foo=DeltaEstimate(a,b,cc,d, p, start=rep(1/9,8), tol=1e-07)

Delta=jacquard(x,ids)
foo2 = lik2vec(a,b,cc,d,p,Delta)

x = Delta[-8]
lik2vec2(x,a,b,cc,d,p)
A = diag(8)
A = rbind(A, rep(-1,8))
B = c(rep(0,8),1)
constraints = list(ineqA=A, ineqB=B)
loglik =function(x) lik2vec2(x,a,b,cc,d,p)
ML = maxLik(loglik, start=rep(1/9,8), constraints=constraints, tol=1e-6)
ML$estimate


test = function(x = fullSibMating(2), ids =c(5,6), pp=rep(0.25,4)){
Delta = jacquard(x, ids)
pp = pp/sum(pp)
res = NULL
# Case 1

g1 = g2 = c(1,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids,g1, afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2,1))
# Case 2
g1 =c(1,1); g2 =c(2,2)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 2))

# Case 3
g1 =c(1,1); g2 =c(2,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 3))

# Case 4
g1 =c(1,1); g2 =c(3,2)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 4))

# Case 5
g1 =c(2,1); g2 =c(1,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 5))

# Case 6
g1 =c(3,2); g2 =c(1,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 6))

# Case 7
g1 =c(1,4); g2 =c(4,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 7))

# Case 8
g1 =c(1,2); g2 =c(4,1)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 8))

# Case 9
g1 =c(1,2); g2 =c(3,4)
a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
m = marker(x, alleles=1:length(pp), ids[1],g1,ids[2],g2,afreq=pp)
l1 = likelihood(x,m)
l2 = lik2(a,b,cc,d, pp, Delta)
res = rbind(res,c(g1,g2,l1,l2, 9))
res
}
test()

res = NULL
x = fullSibMating(3)
Delta = jacquard(x, c(7,8))
L = 2
pp = 1:L; pp = pp/sum(pp)
set.seed(17)
for (i in 1:100){
  g1 = sample(1:L, 2, rep=TRUE, prob=pp)
  g2 = sample(1:L, 2, rep=TRUE, prob=pp)
  a =g1[1];b=g1[2];cc=g2[1];d=g2[2]
  l2 = lik2(a,b,cc,d, pp, Delta)
  m = marker(x, alleles=1:L, 7,g1,8,g2,afreq=pp)
  l1 = likelihood(x,m)
  res = rbind(res,c(g1,g2,l1,l2))
}
foo=apply(res,1,function(x) abs(x[5]-x[6]) < 1e-15)
sum(foo)-100
g1 = c(6,9); g2=c(9,10)



# Function to maximize
logliktot = function(delta){
  loglik = 0
  Delta8 = 1 - sum(delta)
  Delta = c(delta[1:7],Delta8,delta[8])
  for (i in 1:length(afreq))
    loglik = loglik +log(lik2(a[i], b[i],cc[i],d[i],as.double(afreq[[i]]),Delta))
  loglik
}
logliktot(delta)
A = diag(8)
A = rbind(A, rep(-1,8))
B = c(rep(0,8),1)
constraints = list(ineqA=A, ineqB=B)
ss = rep(0,8)
ML = maxLik(logliktot, start=delta, constraints=constraints, tol=1e-07)

1- sum(ML$estimate)
