\name{LRmoments2}
\alias{LRmoments2}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Calculates expectation, standard deviation and skewness of LR under HP and HD
}
\description{
Exact numerical calculation. 
}
\usage{
LRmoments2(p = c(0.5, 0.5), kappaP = c(0, 1, 0),kappaD = c(1, 0, 0),logg=FALSE, base =exp(1))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p}{
Allele frequencies
}
  \item{kappaP}{
Probabilities of 0,1 and 2 alleles IBD corresponding to pedigree for HP
}
  \item{kappaD}{
Probabilities of 0,1 and 2 alleles IBD corresponding to pedigree for HD
}
  \item{logg}{
If \code{TRUE, LR} is log transformed with basis base (below).
}
  \item{base}{
Base for log transform
}

}

\value{
\item{moments }{expectation, standard deviation and skewness of LR under HP and HD}
\item{LRtable}{Distribution of LR under HP and HD}

}
\references{
Slooten and Egeland (2013, submitted)
}
\author{
Thore Egeland Thore.Egeland@gmail.com
}

\examples{
require(paramlink)


LRmoments2(kappaP=c(0,1,0)) #Motivating example
\dontrun{
data(db)
p=db[db$Marker=="VWA",]$Freq
LRmoments2(p=p,kappaP=c(0,1,0))}

#Log example
x <- 0.1
res <- LRmoments2(kappaP=c(0,1,0), p = c(x,1-x),logg=TRUE)

#Exact
logE <- function(x) {
term1 <- x^3*log(1/x)+2*x^2*(1-x)*log(1/(2*x))+2*x*(1-x)^2*log(1/(2-2*x))
term2 <- x*(1-x)*log(1/(4*x*(1-x)))+(1-x)^3*log(1/(1-x))
term1+term2
}
round(res$moments[1],15)==round(logE(x),15)

}
