\name{exampleKrakow}
\alias{exampleKrakow}

\title{
Krakow homework
}
\description{
For a specific example, detailed in Krakow Sep 1 course, P(M|Hp) and P(M|Hd) are calculated.
The conditional likelihoods are done using \link{conditionalLikelihoods}
and the genotype  probabilities, i.e., P(g1,g2) are found using the \link{FamiliasPosterior}
wrapper \link{mix3Familias}.
The function indicates how other cases are handled.
}
\usage{
exampleKrakow(p, R, theta, M, c, d)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p}{
Allele frequencies, real vector
}
  \item{R}{
Mutation rate, real in [0,1]. Default Familias model is used
}
  \item{theta}{
Kinship coefficient, real in [0,1].
}
  \item{M}{
Integer vector, subset of 1,2,3,4 for this function.
}
  \item{c}{
Dropin parameter, real in [0,1]
}
  \item{d}{
Drop-out. A real vector with two numbers for this function.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
\item{lik.p }{P(M|Hp)}
\item{lik.d }{P(M|Hd)}
\item{LR}{P(M|Hp)/P(M|Hd)}
%% ...
}
\references{
See Krakow talks.
}
\author{
Thore Egeland
}

\examples{
#Homework
require(Familias)
require(paramlink)
p <- c(0.01,0.01,0.01,0.97) #allele frequencies
R <- 0 #mutation rate
theta <- 0 #kinship parameter
M <- c(1,2,3) #Mixture
c <- 0.0 #dropin parameter
d <- c(0.0,0.0) #drop-out parameters for the two contributors
exampleKrakow(p, R, theta, M, c,d)
}
