\name{expectedCost}
\alias{expectedCost}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Expected cost
}
\description{
Calculates expected costs, Section 8.1.2, by an asymptotic approach
}
\usage{
expectedCost(mu.1.log, sd.1.log, mu.2.log, sd.2.log, n, L.L = 1/10000, L.H = 10000, odds = 1, c.D = 0.1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{mu.1.log}{
Expected value of log(X1)
}
  \item{sd.1.log}{
Standard deviation of log(X1)
}
  \item{mu.2.log}{
Expected value of log(X2)
}
  \item{sd.2.log}{
Standard deviation of log(X2)
}
  \item{n}{
Number of markers assumed iid
}
  \item{L.L}{
Lower bound
}
  \item{L.H}{
Upper bound
}
  \item{odds}{
Prior odds
}
  \item{c.D}{
Cost of aqcuiring data
}
}

\value{
\item{p1}{First probability in formula for V}
\item{p2}{Second probability in formula for V}
\item{p3}{Third probability in formula for V}
\item{p4}{Fourth probability in formula for V}
\item{ExpectedCost}{Expected cost}
}

\author{
Thore Egeland <Thore.Egeland@nmbu.no>
}


\examples{
require(Familias)
data(NorwegianFrequencies)
p <- as.double(NorwegianFrequencies[1][[1]])
L <- length(p)
m <- LRmoments2(p, kappaP = c(0.5,0.5,0), kappaD = c(1,0,0), 
                logg = TRUE)$moments[c(1,3,5,7)]
m <- as.double(m)
expectedCost(m[1], m[2],m[3], m[4], n=25, 
             L.L=1/100, L.H =100, odds = 1 , c.D = 0.1)
}

