\name{mix3Familias}
\alias{mix3Familias}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Relationships with mixtures
}
\description{
The likelihood for relationships problems
with mixture and reference profiles is calculated 
}
\usage{
mix3Familias(pedigrees, locus, datamatrix, kinship = 0)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pedigrees}{
\code{pedigrees} A list of Familias pedigrees
}
  \item{locus}{
A Familias locus
}
  \item{datamatrix}{
Each line corresponds to one constellation 
of geneotypes for the individuals
}
  \item{kinship}{
Theta parameter
}
}

\value{
The likelihoods for the pedigrees and detailed output for each term in the sum
}
\references{
Egeland, Kling, Mostad (2015)
}
\author{
Thore Egeland <Thore.Egeland@nmbu.no>
}

\examples{
require(Familias)
persons <- c( "CH", "MO", "AF")
ped1 <- pedigree( id = persons, dadid = c( "AF", NA, NA), 
                  momid = c( "MO", NA, NA), 
sex <- c( "male", "female", "male"))
ped2 <- pedigree( id = c( persons, "TF"), 
                  dadid = c( "TF", NA, NA, NA), 
                  momid =c ( "MO", NA, NA, NA), 
                  sex =c ( "male", "female", "male", "male"))
pedigrees <- list( isFather = ped1, unrelated = ped2)
E <- 1:3 ; gAF <- c( 3,4)
datamatrix <- generate( E, K = NULL, 2)
AF <- rep( gAF, dim(datamatrix)[2]/2)
datamatrix <- rbind(datamatrix,AF)
datamatrix <- as.data.frame(datamatrix)
rownames(datamatrix)[c(1,2)] = c( "CH", "MO")
R <- 0.01
theta <- 0.01
locus <- FamiliasLocus( frequencies = rep( 0.2, 5), name = "V1",  
                        allelenames = c( 1:5),
                        femaleMutationRate = R, maleMutationRate = R)
mix3Familias( pedigrees, locus, datamatrix)
}

